 <template>
  
  <div class="card chat-box">
    <div class="card-header">
      <vue-status>
        <span slot="online" class="badge badge-pill badge-success">Terhubung</span>
        <span slot="offline" class="badge badge-pill badge-danger">Koneksi Internet Bermasalah</span>
      </vue-status>
      <b class="mt-2" :class="{'text-danger':session.block}">
        {{friend.name}} <span v-if="isTyping">sedang mengetik...</span>
        <span class="ml-1 text-danger" v-if="session.block">(Blocked)</span>
      </b>
      
      <a @click.prevent="close" class="float-right">
        <i class="fa fa-times"></i>
      </a>

      <div class="dropdown mr-4 float-right d-inline">
        <a role="button" id="dropdownMenuLink" data-toggle="dropdown">
          <i class="fa fa-ellipsis-v"></i>
        </a>

        <div class="dropdown-menu" aria-labelledby="dropdownMenuLink">
          <a @click.prevent="clearChat" class="dropdown-item" href="#">Clear Chat</a>
          <a 
            class="dropdown-item"
            @click.prevent="unblockUser"
            v-if="session.block && can"
            href="#">Unblock User</a>
          <a
            class="dropdown-item"
            @click.prevent="blockUser"
            v-if="!session.block"
            href="#"
          >Block User</a>
          
        </div>
      </div>
    </div>
    <div class="card-body" v-chat-scroll="{always: true, smooth: true}">
      <p
        class="card-text d-flex"
        :class="{'justify-content-start': chat.type==0, 'justify-content-end' : chat.type == 1}"
        v-for="chat in chats"
        :key="chat.id"
      >
        {{chat.message}}
        <span>
          <small class="ml-3 badge badge-light">{{chat.send_at}}</small>
        </span>
        <i
          class="ml-2 mt-2 fas fa-check"
          :class="{'text-success': chat.read_at != null, 'text-mark' : chat.read_at == null }"
        ></i>
      </p>
    </div>

    <div class="card-footer">
      <form method="post" @submit.prevent="send">
        <div class="row">
          <div class="col-sm-10">
            <textarea
              rows="3"
              v-model="message"
              name="message"
              class="form-control"
              placeholder="Tulis Pesan Anda ..."
              v-bind:disabled="session.block"
            ></textarea>
          </div>
          <div class="col-sm-2">
            <button type="submit" class="btn-block btn btn-primary">Kirim</button>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import VueStatus from "vue-status";

export default {
  name: "message-component",
  components: {
    VueStatus
  },
  props: ["friend"],
  computed: {
    session() {
      return this.friend.session;
    },
    can() { //can block checker
      return this.session.blocked_by == auth.id;
    }
  },
  watch: {
    message(value) {
      if(value){
        Echo.private(`Chat.${this.session.id}`)
          .whisper("typing",{
            name: auth.name
          });
      }
    }
  },
  data() {
    return {
      open: true,
      message: null,
      chats: [],
      isTyping: false,
    };
  },
  created() {
    this.read();
    this.getAllMessages();

    // Channel private chat user berdasarkan session
    // Event Private 1-1 user session chat
    Echo.private(`Chat.${this.friend.session.id}`).listen(
      "PrivateChatEvent",
      e => {
        this.friend.session.open ? this.read() : "";
        this.chats.push({
          message: e.content,
          type: 1,
          send_at: moment().format("HH:mm")
        });
      }
    );

    // Event Read Message
    Echo.private(`Chat.${this.friend.session.id}`).listen(
      "MessageReadEvent",
      e => {
        this.chats.forEach(chat =>
          chat.id === e.chat.id ? (chat.read_at = e.chat.read_at) : ""
        );
      }
    );

    // Block Event
    Echo.private(`Chat.${this.session.id}`).listen(
      "BlockEvent",
      e => {
        console.log(e);
        this.session.block = e.blocked;
      }
    );

    //Watcher
    Echo.private(`Chat.${this.session.id}`)
    .listenForWhisper("typing",
      e=> {
        this.isTyping = true;
        setTimeout(()=>{
          this.isTyping = false;
        },2000)
      }
    );
  },
  methods: {
    getAllMessages() {
      axios.post(`/session/${this.friend.session.id}/chats`).then(res => {
        console.log(`Data responses : ${res.data}`);
        this.chats = res.data.data;
      });
    },
    read() {
      //Baca Pesan Ketika Diklik
      axios.post(`/session/${this.friend.session.id}/read`).then(res => {
        console.log(res);
      });
    },
    send() {
      if (this.message) {
        this.pushMessage(this.message);
        axios
          .post(`/send/${this.friend.session.id}`, {
            content: this.message,
            to_user: this.friend.id
          })
          .then(res => {
            console.log(res.data);
            this.chats[this.chats.length - 1].id = res.data;
          })
          .catch(err => {
            console.log(err);
          });
        this.message = "";
      }
    },
    pushMessage(message) {
      this.chats.push({
        message: message,
        type: 0,
        read_at: null,
        send_at: moment().format("HH:mm")
      });
    },
    close() {
      this.$emit("close");
    },
    clearChat() {
      axios.post(`/session/${this.friend.session.id}/clear`).then(res => {
        this.chats = [];
      });
    },
    blockUser() {
      this.session.block = true;
      axios
        .post(`/session/${this.friend.session.id}/block`)
        .then(res => (this.session.blocked_by = res.data.blocked_by));
    },
    unblockUser() {
      this.session.block = false;
      axios
        .post(`/session/${this.friend.session.id}/unblock`)
        .then(res => this.session.blocked_by = null);
    }
  }
};
</script>

<style scoped>
.chat-box {
  height: 400px;
}

.card-body {
  overflow-y: scroll;
}

a:hover {
  cursor: pointer;
}

.text-mark {
  color: #dddddd;
}
</style>